Attribute VB_Name = "ZZZ_Marcas"
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' IPress (C) 2001,2002,2003 Estndard Lingstic S.L.
'   versi 1.1rev7
'   Concepte i diseny per Ricard Prez
'   Programat per Gerardo Garca
'   Tots els drets reservats.
'
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit

Public Const ZZZ_IdSourceText = 1
Public Const ZZZ_IdTargetText = 2
Public Const ZZZ_TagStart = "<!-- paranum='"
Public Const ZZZ_TagEnd = "' -->"

'/////////////////////////////////////////////////////////////////////////////////////
'//                                                                                 //
'//                                                                                 //
'//                        MARCAS INTERNAS EN EL DOCUMENTO                          //
'//                                                                                 //
'//                                                                                 //
'/////////////////////////////////////////////////////////////////////////////////////


Public Sub ZZZ_MarcaDoc(ByRef doc As Document, ByVal IDFamily As String, ByVal PartInTheMiddle As Integer)
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
'   Marca un documento con un identificador (source/target) y su ID para unirse a su hermano
'
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
  Dim aVar As Variable
  Dim numWho As Integer
  Dim numBrother As Integer

    ' Buscamos una preexistencia de las variables
  For Each aVar In doc.Variables
    If aVar.name = "WhoAmI" Then numWho = aVar.Index
    If aVar.name = "MyBrother" Then numBrother = aVar.Index
  Next

    ' Corregimos el WhoAMI
  If numWho = 0 Then
    doc.Variables.Add name:="WhoAmI", Value:=IDFamily
  Else
    doc.Variables(numWho).Value = IDFamily
  End If
  
    ' Corregimos el ID de su brother
  If numBrother = 0 Then
    doc.Variables.Add name:="MyBrother", Value:=PartInTheMiddle
  Else
    doc.Variables(numBrother).Value = PartInTheMiddle
  End If
End Sub

Public Sub ZZZ_MarcaSource(ByRef doc As Document, ByVal IDFamily As String)
  ZZZ_MarcaDoc doc, IDFamily, ZZZ_IdSourceText
End Sub

Public Sub ZZZ_MarcaTarget(ByRef doc As Document, ByVal IDFamily As String)
  ZZZ_MarcaDoc doc, IDFamily, ZZZ_IdTargetText
End Sub

Public Function ZZZ_EncuentraDoc(ByVal family As String, ByVal brother As Integer) As Document
  Dim doc As Document
  Dim fdoc As Document
  Dim aVar1 As Variable
  Dim aVar2 As Variable
  
  For Each doc In Documents
    For Each aVar1 In doc.Variables
      If aVar1.name = "WhoAmI" Then
        If aVar1.Value = family Then
          For Each aVar2 In doc.Variables
            If aVar2.name = "MyBrother" Then
              If aVar2.Value = brother Then
                Set fdoc = doc
              End If
            End If
          Next aVar2
        End If
      End If
    Next aVar1
  Next doc
  
  Set ZZZ_EncuentraDoc = fdoc
End Function

Public Function ZZZ_EliminaVarsDoc(ByRef doc As Document)
  Dim fdoc As Document
  Dim aVar As Variable
  
  For Each aVar In doc.Variables
    If aVar.name = "WhoAmI" Or aVar.name = "MyBrother" Then
      aVar.Delete
    End If
  Next aVar
  
End Function

Public Function ZZZ_EncuentraSource(ByVal family As String) As Document
  Set ZZZ_EncuentraSource = ZZZ_EncuentraDoc(family, ZZZ_IdSourceText)
End Function

Public Function ZZZ_EncuentraTarget(ByVal family As String) As Document
  Set ZZZ_EncuentraTarget = ZZZ_EncuentraDoc(family, ZZZ_IdTargetText)
End Function

Public Function ZZZ_CompruebaPar(ByVal family As String) As Boolean
  Dim ok1 As Boolean
  Dim ok2 As Boolean
  Dim doc As Document
  Dim aVar1 As Variable
  Dim aVar2 As Variable
  
  ok1 = False
  ok2 = False
  
  For Each doc In Documents
    For Each aVar1 In doc.Variables
      If aVar1.name = "WhoAmI" Then
        If aVar1.Value = family Then
          For Each aVar2 In doc.Variables
            If aVar2.name = "MyBrother" Then
              If aVar2.Value = ZZZ_IdSourceText Then
                ok1 = True
              ElseIf aVar2.Value = ZZZ_IdTargetText Then
                ok2 = True
              End If
            End If
          Next aVar2
        End If
      End If
    Next aVar1
  Next doc
  
  ZZZ_CompruebaPar = ok1 And ok2
End Function

Public Function ZZZ_ObtenerFamily(ByRef doc As Document) As String
  Dim aVar As Variable
  Dim result As String
  result = ""
  For Each aVar In doc.Variables
    If aVar.name = "WhoAmI" Then
      result = aVar.Value
    End If
  Next aVar
  ZZZ_ObtenerFamily = result
End Function

Public Function ZZZ_ObtenerId(ByRef doc As Document) As Integer
  Dim aVar As Variable
  Dim result As Integer
  For Each aVar In doc.Variables
    If aVar.name = "MyBrother" Then
      result = aVar.Value
    End If
  Next aVar
  ZZZ_ObtenerId = result
End Function

Public Function ZZZ_IsMarked(ByRef doc As Document) As Boolean
  Dim aVar As Variable
  Dim result1 As Boolean
  Dim result2 As Boolean
  result1 = False
  result2 = False
  For Each aVar In doc.Variables
    If aVar.name = "MyBrother" Then
      result1 = True
    ElseIf aVar.name = "WhoAmI" Then
      result2 = True
    End If
  Next aVar
  ZZZ_IsMarked = result1 And result2
End Function

'/////////////////////////////////////////////////////////////////////////////////////
'//                                                                                 //
'//                                                                                 //
'//                             MARCAS EN EL DOCUMENTO                              //
'//                                                                                 //
'//                                                                                 //
'/////////////////////////////////////////////////////////////////////////////////////

Public Function ZZZ_generaMarca(ByVal tagnumber As Integer, ByVal begin_paragraph As Boolean) As String
  If tagnumber < 0 Then
    ZZZ_generaMarca = ""
  Else
    If begin_paragraph Then
      ZZZ_generaMarca = ZZZ_TagStart & Format(tagnumber, "000000") & "b" & ZZZ_TagEnd
    Else
      ZZZ_generaMarca = ZZZ_TagStart & Format(tagnumber, "000000") & "c" & ZZZ_TagEnd
    End If
  End If
End Function

Public Function ZZZ_generaSubMarca(ByVal tagnumber As Integer) As String
  If tagnumber < 0 Then
    ZZZ_generaSubMarca = ""
  Else
    ZZZ_generaSubMarca = ZZZ_TagStart & Format(tagnumber, "000000") & "^?" & ZZZ_TagEnd
  End If
End Function


Public Function ZZZ_DetectaMarcas(ByRef doc As Document) As Boolean
  Dim rngDoc As Range
  Set rngDoc = doc.Content
  
  ' Incluimos en el rango el texto oculto
  rngDoc.TextRetrievalMode.IncludeHiddenText = True
  
  'Hacemos la busqueda de la marca
  With rngDoc.Find
      ' Limpiamos las propiedades
    .ClearFormatting
      ' Ponemos parametros de busqueda
    .Text = ZZZ_TagStart
    .Replacement.Text = ""
    .Forward = True
    .Wrap = wdFindContinue
    .Format = False
    .MatchCase = False
    .MatchWholeWord = False
    .MatchWildcards = False
    .MatchSoundsLike = False
    .MatchAllWordForms = False
  End With
    ' Ejecutamos la busqueda a lo bestia
  ZZZ_DetectaMarcas = rngDoc.Find.Execute
End Function

Public Sub ZZZ_insertarMarcas(ByRef doc As Document, ByVal zzz_prep As Boolean)
  Dim a As Paragraph
  Dim popopo As Range
  Dim tagnumber As Integer
  Dim StrTag As String
  Dim i As Long
  Dim j As Long
  Dim auto_j As Long

    'eliminamos los caracteres extraos!
  Set popopo = doc.Content
  
  popopo.TextRetrievalMode.IncludeHiddenText = True
  Do
    With popopo.Find
      .Text = Chr$(11)
      .ClearFormatting
      .Replacement.Text = ""
      .Replacement.ClearFormatting
      .Forward = True
      .Format = False
      .MatchCase = False
      .MatchWholeWord = False
      .MatchWildcards = False
    End With
    If popopo.Find.Execute(Replace:=wdReplaceOne) Then
      popopo.InsertParagraphBefore
    Else
      Exit Do
    End If
  Loop
  
  Set popopo = Nothing
  
    ' ponemos las marcas ahora!
  tagnumber = 0
  i = 1
  auto_j = ((doc.Paragraphs.Count * 3) / 100)
  j = auto_j
  If zzz_prep Then
    ZZZ_PreparingWindow.cambia_label doc.name, 0
  End If
  For Each a In doc.Paragraphs
    If j <= 0 Then
      If zzz_prep Then
        ZZZ_PreparingWindow.cambia_label doc.name, ((i * 100) / doc.Paragraphs.Count)
        j = auto_j
      End If
    Else
      j = j - 1
    End If
    If a.Range.Characters.Count > 1 Then
      If ZZZ_IsThereTextInRange(a.Range) Then
        ' generamos una nueva marca
        StrTag = ZZZ_generaMarca(tagnumber, True)
        ' la insertamos en el texto
        a.Range.InsertBefore StrTag
        ' la ocultamos
        Set popopo = doc.Range(a.Range.Characters(1).Start, a.Range.Characters(1).Start + Len(StrTag))
        'MsgBox popopo.Text
        popopo.Font.Hidden = True
        ' incrementamos tagnumber
        tagnumber = tagnumber + 1
      End If
    End If
    i = i + 1
  Next
  If zzz_prep Then
    ZZZ_PreparingWindow.cambia_label doc.name, 100
  End If
End Sub

Public Sub ZZZ_insertarMarcasOld(ByRef doc As Document)
  Dim lastchar As Integer
  Dim newchar As Integer
  Dim milines As Integer
  Dim a As Paragraph
  Dim popopo As Range
  Dim tagnumber As Integer
  Dim StrTag As String
    
  ' Valores iniciales
  lastchar = 13
  milines = 1
  tagnumber = 0
    
  ' Bucle de tratamiento
  For Each a In doc.Paragraphs
    newchar = Asc(a.Range.Characters.First)
    milines = milines + 1
    If (((lastchar = 13) And (newchar <> 13)) Or (milines > 5)) Then
      ' Insertamos el tag
      StrTag = ZZZ_generaMarca(tagnumber, (Not (milines > 5)) Or ((lastchar = 13) And (newchar <> 13)))
      ' Reseteamos milines
      milines = 1
      a.Range.InsertBefore StrTag
      tagnumber = tagnumber + 1
      ' Ocultamos el tag
      Set popopo = doc.Range(a.Range.Characters(1).Start, a.Range.Characters(Len(StrTag)).End)
      popopo.Font.Hidden = True
    End If
    lastchar = newchar
  Next
End Sub

Public Sub ZZZ_DestruyeMarcas(ByRef doc As Document, ByVal hide As Boolean)
  Dim r As Range
  
  If IsObjectValid(doc) Then
    Set r = doc.Content
    r.TextRetrievalMode.IncludeHiddenText = True
    With r.Find
      .Text = ZZZ_TagStart + "^?^?^?^?^?^?^?" + ZZZ_TagEnd
      .ClearFormatting
      .Replacement.Text = ""
      .Replacement.ClearFormatting
      .Forward = True
      .Format = False
      .MatchCase = False
      .MatchWholeWord = False
      .MatchWildcards = False
      '.MatchSoundsLike = False
      '.MatchAllWordForms = False
    End With
    r.Find.Execute Replace:=wdReplaceAll
    Set r = Nothing
  End If
End Sub

Public Sub ZZZ_OcultaMarcas(ByRef doc As Document, ByVal hide As Boolean)
  Dim r As Range
  
  Set r = doc.Content
  r.TextRetrievalMode.IncludeHiddenText = True
  Do
    With r.Find
      .Text = ZZZ_TagStart + "^?^?^?^?^?^?^?" + ZZZ_TagEnd
      .ClearFormatting
      .Replacement.Text = ""
      .Replacement.ClearFormatting
      .Forward = True
      .Format = False
      .MatchCase = False
      .MatchWholeWord = False
      .MatchWildcards = False
'      .MatchSoundsLike = False
'      .MatchAllWordForms = False
    End With
    If r.Find.Execute Then
      r.Font.Hidden = hide
    Else
      Exit Do
    End If
  Loop
  Set r = Nothing
End Sub

Public Sub ZZZ_ObtenerMarcasParrafo(ByRef doc As Document, ByRef begin_tag As String, ByRef end_tag As String)
  Dim encontre_principio_parrafo As Boolean
  Dim encontre_final_parrafo As Boolean
  Dim fin As Boolean
  Dim act_p As Paragraph
  Dim r As Range
    
  encontre_principio_parrafo = False
  encontre_final_parrafo = False
  
    ' buscamos el principio del parrafo donde estamos
  Set act_p = Selection.Paragraphs.First
  fin = False
  While ((Not fin) And (Not encontre_principio_parrafo))
    If IsObjectValid(act_p) Then
      Set r = doc.Range(act_p.Range.Start, act_p.Range.End)
      r.TextRetrievalMode.IncludeHiddenText = True
      With r.Find
        .ClearFormatting
        .Text = ZZZ_TagStart + "^?^?^?^?^?^?b" + ZZZ_TagEnd
        .Replacement.Text = ""
        .Forward = False
        .Wrap = wdFindStop
        .Format = False
        .MatchCase = False
        .MatchWholeWord = False
        .MatchWildcards = False
        .MatchSoundsLike = False
        .MatchAllWordForms = False
      End With
      If r.Find.Execute Then
        begin_tag = r.Text
        r.Collapse (wdCollapseEnd)
        r.Select
        encontre_principio_parrafo = True
      Else
        Set act_p = act_p.Previous(1)
      End If
      Set r = Nothing
    Else
      fin = True
    End If
  Wend
  
  If Not encontre_principio_parrafo Then
    begin_tag = ""
  End If
  
    ' Buscamos el final del parrafo donde estamos
  Set act_p = Selection.Paragraphs.First
  fin = False
  While ((Not fin) And (Not encontre_final_parrafo))
    If IsObjectValid(act_p) Then
      Set r = doc.Range(act_p.Range.Start, act_p.Range.End)
      r.TextRetrievalMode.IncludeHiddenText = True
      With r.Find
        .ClearFormatting
        .Text = ZZZ_TagStart + "^?^?^?^?^?^?b" + ZZZ_TagEnd
        .Replacement.Text = ""
        .Forward = True
        .Wrap = wdFindStop
        .Format = False
        .MatchCase = False
        .MatchWholeWord = False
        .MatchWildcards = False
        .MatchSoundsLike = False
        .MatchAllWordForms = False
      End With
      If r.Find.Execute And (begin_tag <> r.Text) Then
        end_tag = r.Text
        r.Collapse (wdCollapseStart)
        r.Select
        encontre_final_parrafo = True
      Else
        Set act_p = act_p.Next(1)
      End If
      Set r = Nothing
    Else
      fin = True
    End If
  Wend
  
  If Not encontre_final_parrafo Then
    end_tag = ""
  End If
End Sub

Public Function ZZZ_ObtenerRangeMarcas(ByRef doc As Document, ByVal begin_tag As String, ByVal end_tag As String) As Range
  Dim r As Range
  Dim start_p As Long
  Dim end_p As Long
  
  If begin_tag <> "" Then
    Set r = doc.Content
    r.TextRetrievalMode.IncludeHiddenText = True
    With r.Find
      .ClearFormatting
      .Text = begin_tag
      .Replacement.Text = ""
      .Forward = True
      .Wrap = wdFindStop
      .Format = False
      .MatchCase = False
      .MatchWholeWord = False
      .MatchWildcards = False
      .MatchSoundsLike = False
      .MatchAllWordForms = False
    End With
    If r.Find.Execute Then
      start_p = r.End
    End If
  Else
    start_p = doc.Characters.First.Start
  End If
  
  Set r = Nothing
  
  If end_tag <> "" Then
    Set r = doc.Content
    r.TextRetrievalMode.IncludeHiddenText = True
    With r.Find
      .ClearFormatting
      .Text = end_tag
      .Replacement.Text = ""
      .Forward = True
      .Wrap = wdFindStop
      .Format = False
      .MatchCase = False
      .MatchWholeWord = False
      .MatchWildcards = False
      .MatchSoundsLike = False
      .MatchAllWordForms = False
    End With
    If r.Find.Execute Then
      'r.Collapse (wdCollapseStart)
      'r.Select
      end_p = r.Start
    End If
  Else
    end_p = doc.Characters.Last.Start
  End If
  
  Set r = Nothing
  
  If end_p < start_p Then
    end_p = start_p
  End If
  Set ZZZ_ObtenerRangeMarcas = doc.Range(start_p, end_p)
End Function

Public Sub ZZZ_IrAMarcaByName(ByRef doc As Document, ByVal tag As String, Optional before As Boolean = True)
  Dim r As Range
  
  Set r = doc.Content
  doc.Activate
  r.TextRetrievalMode.IncludeHiddenText = True
  With r.Find
    .ClearFormatting
    .Text = tag
    .Replacement.Text = ""
    .Forward = True
    .Wrap = wdFindStop
    .Format = False
    .MatchCase = False
    .MatchWholeWord = False
    .MatchWildcards = False
    .MatchSoundsLike = False
    .MatchAllWordForms = False
  End With
  r.Find.Execute
  If before Then
    r.Collapse wdCollapseStart
  Else
    r.Collapse wdCollapseEnd
  End If
  Selection.Start = r.Start
  Selection.Collapse
End Sub

Public Sub ZZZ_IrAMarca(ByRef doc As Document, ByVal ntag As Integer)
  Dim i As Integer
  Dim j As Integer
  Dim maxtag As Integer
  Dim fin As Boolean
  Dim r As Range
  
    ' Activamos el documento
  doc.Activate
    ' Creamos un rango con todo el documento
  Set r = doc.Content
  
    ' Situamos i y j, y la cota maxima
  i = ntag
  j = ntag
  If doc.Paragraphs.Count > ntag Then
    maxtag = doc.Paragraphs.Count
  Else
    maxtag = ntag
  End If
  fin = False
  
    ' Comenzamos el bucle
  While ((i >= 0) Or (j <= maxtag)) And Not fin
    If i >= 0 Then
      r.TextRetrievalMode.IncludeHiddenText = True
      
      With r.Find
        .ClearFormatting
        .Text = ZZZ_generaSubMarca(i)
        .Replacement.Text = ""
        .Forward = True
        .Wrap = wdFindContinue
        .Format = False
        .MatchCase = False
        .MatchWholeWord = False
        .MatchWildcards = False
        .MatchSoundsLike = False
        .MatchAllWordForms = False
      End With
      If r.Find.Execute Then
        fin = True
        r.Collapse
        r.Select
      Else
        i = i - 1
      End If
    End If
    If j <= maxtag And Not fin Then
      r.TextRetrievalMode.IncludeHiddenText = True
      With r.Find
        .ClearFormatting
        .Text = ZZZ_generaSubMarca(j)
        .Replacement.Text = ""
        .Forward = True
        .Wrap = wdFindContinue
        .Format = False
        .MatchCase = False
        .MatchWholeWord = False
        .MatchWildcards = False
        .MatchSoundsLike = False
        .MatchAllWordForms = False
      End With
      If r.Find.Execute Then
        fin = True
        r.Collapse
        r.Select
      Else
        j = j + 1
      End If
    End If
  Wend
  If Not fin Then
    Selection.Start = doc.Content.Characters.Last.Start
    Selection.End = Selection.Start
  End If
End Sub
