Attribute VB_Name = "ZZZ_Synchro"
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' IPress (C) 2001,2002,2003 Estndard Lingstic S.L.
'   versi 1.1rev7
'   Concepte i diseny per Ricard Prez
'   Programat per Gerardo Garca
'   Tots els drets reservats.
'
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit

Public Function ZZZ_nearestTagOnOneDirection(ByVal forguard As Boolean, ByVal actualtagnum As Long) As Integer
  Dim act_p As Paragraph
  Dim fin As Boolean
  Dim r As Range
  Dim tag As String
  Dim tagnumber As Integer
  
    ' Averiguamos nuestro parrafo actual
  Set act_p = Selection.Paragraphs.First
  
    ' Nos recorremos todos los tags a partir de la posicin actual
    ' en el siguiente bucle
  tagnumber = -1
  fin = False
  While IsObjectValid(act_p) And Not fin
    Set r = ActiveDocument.Range(act_p.Range.Start, act_p.Range.End)
    r.TextRetrievalMode.IncludeHiddenText = True
    With r.Find
      .ClearFormatting
      .Text = ZZZ_TagStart
      .Replacement.Text = ""
      .Forward = forguard
      .Wrap = wdFindStop
      .Format = False
      .MatchCase = False
      .MatchWholeWord = False
      .MatchWildcards = False
      .MatchSoundsLike = False
      .MatchAllWordForms = False
    End With
    If r.Find.Execute Then
        ' Hemos encontrado una marca. La recogemos en el string tag
      r.SetRange Start:=r.Start, End:=r.Start + Len(ZZZ_TagStart) + 7 + Len(ZZZ_TagEnd)
      tag = r.FormattedText
        ' Pillamos el numero de marca
      If Len(tag) > 0 Then
        tagnumber = Val(Mid(tag, Len(ZZZ_TagStart) + 1, 6))
        If tagnumber <> actualtagnum Then
           ' Al parecer es un tag distinto al actual, as que damos la tarea
           ' por finalizada
          fin = True
        Else
          tagnumber = -1
        End If
      End If
    End If
    
      ' Si no se encontr ningn tag adecuado, avanzamos al siguiente parrafo
      ' y reintentamos la operacin
    If Not fin Then
      If forguard Then
        Set act_p = act_p.Next(1)
      Else
        Set act_p = act_p.Previous(1)
      End If
    End If
    Set r = Nothing
  Wend
  
    ' Devolvemos el tag encontrado
  ZZZ_nearestTagOnOneDirection = tagnumber
End Function

Public Function ZZZ_nearestTag() As Long
  Dim fin As Boolean
  Dim rup As Range, rdown As Range
  Dim tagup As String, tagdown As String
  Dim max_pos As Long, ini_pos As Long
  Dim tagnumber As Integer

    ' Averiguamos el tamao del documento
  Set rup = ActiveDocument.Range
  rup.WholeStory
  max_pos = rup.End
  Set rup = Nothing
  ini_pos = Selection.Start
  
  Set rup = ActiveDocument.Range(0, ini_pos)
  rup.TextRetrievalMode.IncludeHiddenText = True
  With rup.Find
    .ClearFormatting
    .Text = ZZZ_TagStart
    .Replacement.Text = ""
    .Forward = False
    .Wrap = wdFindStop
    .Format = False
    .MatchCase = False
    .MatchWholeWord = False
    .MatchWildcards = False
    .MatchSoundsLike = False
    .MatchAllWordForms = False
  End With
  If rup.Find.Execute Then
    rup.SetRange Start:=rup.Start, End:=rup.Start + Len(ZZZ_TagStart) + 7 + Len(ZZZ_TagEnd)
    tagup = rup.FormattedText
  Else
    Set rup = Nothing
    tagup = ""
  End If
  
  Set rdown = ActiveDocument.Range(ini_pos, max_pos)
  rdown.TextRetrievalMode.IncludeHiddenText = True
  With rdown.Find
    .ClearFormatting
    .Text = ZZZ_TagStart
    .Replacement.Text = ""
    .Forward = True
    .Wrap = wdFindStop
    .Format = False
    .MatchCase = False
    .MatchWholeWord = False
    .MatchWildcards = False
    .MatchSoundsLike = False
    .MatchAllWordForms = False
  End With
  If rdown.Find.Execute Then
    rdown.SetRange Start:=rdown.Start, End:=rdown.Start + Len(ZZZ_TagStart) + 7 + Len(ZZZ_TagEnd)
    tagdown = rdown.FormattedText
  Else
    Set rdown = Nothing
    tagdown = ""
  End If
  
  tagnumber = -1
  If tagdown <> "" Then
    tagnumber = Val(Mid(tagdown, Len(ZZZ_TagStart) + 1, 6))
  End If
  If tagup <> "" Then
    tagnumber = Val(Mid(tagup, Len(ZZZ_TagStart) + 1, 6))
  End If
  If tagnumber < 0 Then
    MsgBox "No vaig trobar cap marca per orientarme!", vbExclamation, "IPress: Tinc problemes!"
  End If
  
  ZZZ_nearestTag = tagnumber
End Function


Public Sub ZZZ_aproxima_palabra(ByRef doc_activo As Document, ByRef doc_otro As Document, ByVal bgntag As Long)
  Dim edntag As Long
  Dim rng As Range
  Dim percentpa As Double
  
    ' Activamos el doc_activo
  doc_activo.Activate
    ' Encontramos el final de parrafo del doc doc_activo
  edntag = ZZZ_nearestTagOnOneDirection(True, bgntag)
    ' Calculamos el rango que corresponde al parrafo activo en doc_activo
  Set rng = ZZZ_ObtenerRangeMarcas(doc_activo, ZZZ_generaSubMarca(bgntag), ZZZ_generaSubMarca(edntag))
  If (rng.End - rng.Start) > 0 Then
    percentpa = (Selection.Start - rng.Start) / (rng.End - rng.Start)
  Else
    percentpa = 0
  End If
  If percentpa < 0 Then percentpa = 0
  If percentpa > 1 Then percentpa = 1
  Set rng = Nothing
  
    ' Calculamos la longitud del parrafo destino
  doc_otro.Activate
    ' Vamos al parrafo correspondiente
  ZZZ_IrAMarca doc_otro, bgntag
    ' Buscamos el final de parrafo del doc doc_otro
  edntag = ZZZ_nearestTagOnOneDirection(True, bgntag)
    ' Calculamos el rango que corresponde al parrafo activo en doc_otro
  Set rng = ZZZ_ObtenerRangeMarcas(doc_otro, ZZZ_generaSubMarca(bgntag), ZZZ_generaSubMarca(edntag))
  Selection.Start = ((rng.End - rng.Start) * percentpa) + rng.Start
  Selection.Collapse
  Set rng = Nothing
End Sub

Public Sub ZZZ_DoSynchro()
  Dim ntag As Integer
  Dim played_alive_doc As Document
  Dim external_life_doc As Document
  
  If Documents.Count > 0 Then
    Set played_alive_doc = ActiveDocument
    If ZZZ_CompruebaPar(ZZZ_ObtenerFamily(played_alive_doc)) Then
      ' Buscamos la marca mas cercana
      ntag = ZZZ_nearestTag
        ' Comprobamos si es valida, y si lo es nos dirigimos a ella en la traduccion
      If ntag >= 0 Then
        ZZZ_SetupWindows ZZZ_ObtenerFamily(played_alive_doc)
        If ZZZ_ObtenerId(played_alive_doc) = ZZZ_IdSourceText Then
          Set external_life_doc = ZZZ_EncuentraTarget(ZZZ_ObtenerFamily(played_alive_doc))
        Else
          Set external_life_doc = ZZZ_EncuentraSource(ZZZ_ObtenerFamily(played_alive_doc))
        End If
        ZZZ_aproxima_palabra played_alive_doc, external_life_doc, ntag
      End If
    Else
      MsgBox "El fitxer tradut no est carregat."
    End If
  Else
    MsgBox "No hi ha cap document obert on treballar!", vbExclamation, "Atenci!"
  End If
End Sub

